var HH = HH || {};
HH.TargetParams = HH.TargetParams || {};
HH.banners = {
    bannerJsons: [],
    init: function(){
        HH.banners.bannerJsons.map(function(json){
            var bannerJson = json.banners[0];
            var place = document.querySelector('.banner-place_' + bannerJson.place);
            if(bannerJson && place){
                place.style.display = 'block';
                HH.banners.handlers[bannerJson.type](bannerJson, place);
            }
        });
    },
    put: function(json) {
        HH.banners.bannerJsons.push(json);
    },
    handlers: {
        external: function(banner, bannerPlace) {
            var iframe = document.createElement('iframe');
            iframe.style.width = (banner.width || 0) + 'px';
            iframe.style.height = (banner.height || 0) + 'px';
            iframe.src = banner.src;
            iframe.frameBorder = 'no';
            iframe.scrolling = 'no';

            bannerPlace.appendChild(iframe);
        },
        image: function(banner, bannerPlace) {
            var a = document.createElement('a');
            a.href = banner.click;
            a.target = '_blank';
           
            var img = document.createElement('img');
            img.src = banner.src;
            
            a.appendChild(img);
            bannerPlace.appendChild(a);
        },
        flash: function(banner, bannerPlace) {
            var hasFlash = !!(navigator.mimeTypes["application/x-shockwave-flash"] || window.ActiveXObject && new ActiveXObject('ShockwaveFlash.ShockwaveFlash'));
            if(hasFlash){
                var img = document.createElement('img');
                img.src = 'http://i.hh.ru/images/dot.gif';
                img.width = banner.width;
                img.height = banner.height;
                img.style.position = 'absolute';
                img.onclick = function(){window.open(banner.click);};

                var embed = document.createElement('embed');
                embed.setAttribute('height', banner.height);
                embed.setAttribute('width', banner.width);
                embed.setAttribute('align', 'middle');
                embed.setAttribute('type', 'application/x-shockwave-flash');
                embed.setAttribute('pluginspage', 'http://www.adobe.com/go/getflashplayer');
                embed.setAttribute('allowscriptaccess', 'always');
                embed.setAttribute('name', 'banner_' + banner.id);
                embed.setAttribute('quality', 'high');
                embed.setAttribute('wmode', 'transparent');
                embed.setAttribute('src', 'http://hh.ru/file/5127313.swf');
                embed.setAttribute('flashvars', 'swfUrl=' + banner.src + '&targetUrl=' + banner.click);
                embed.setAttribute('scale', 'noScale');
                embed.setAttribute('bgcolor', 'none');

                bannerPlace.appendChild(img);
                bannerPlace.appendChild(embed);
            } else if(banner.poster){
                banner.src = banner.poster;
                HH.banners.handlers['image'](banner, bannerPlace);
            }
        },
        html: function(banner, bannerPlace) {
            bannerPlace.onclick = function(){window.open(banner.click);};
            bannerPlace.innerHTML = banner.body;

            //временный костыль для таргетинга баннеров mail.ru
            var bannerMailru = bannerPlace.querySelector('#target-banner-mailru');
            
            if (bannerMailru) {
                var params = ['language', 'age', 'gender', 'wage', 'education', 'profarea', 'userId', 'random'];
                for (var i = 0, l = params.length; i < l; i++) {
                    bannerMailru.src = bannerMailru.src.replace('data-'+params[i], HH.TargetParams[params[i]] || '');
                }
            }
        }
    }
};

if (window.jQuery) {
    jQuery(HH.banners.init);
} else if (window.Prototype) {
    Event.observe(document, 'dom:loaded', HH.banners.init);
} else if (window.addEventListener) {
    window.addEventListener('load', HH.banners.init);
} else if (window.attachEvent) {
    window.attachEvent('onload', HH.banners.init);
}
